/*
 * arch/arm/mach-tegra/gpio-pe2.h
 *
 * Copyright (c) 2011, NVIDIA Corporation.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef _MACH_TEGRA_GPIO_PE2_H
#define _MACH_TEGRA_GPIO_PE2_H
#include <mach/pinmux.h>
#include "board-acer-t30.h"
#include "gpio.h"

static __initdata struct tegra_pingroup_config picasso_E2_pinmux_common[] = {
	DEFAULT_PINMUX(CLK1_OUT,        EXTPERIPH1,      NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(DAP1_DIN,        I2S0,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(DAP1_DOUT,       I2S0,            PULL_DOWN,     TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(DAP1_FS,         I2S0,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(DAP1_SCLK,       I2S0,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(DAP2_DIN,        I2S1,            NORMAL,        NORMAL,     INPUT), ////// check config state
	DEFAULT_PINMUX(DAP2_DOUT,       I2S1,            NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(DAP2_FS,         I2S1,            NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(DAP2_SCLK,       I2S1,            NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(SPDIF_IN,        SPDIF,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SPDIF_OUT,       SPDIF,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SPI1_CS0_N,      SPI1,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SPI1_MISO,       SPI1,            PULL_DOWN,     TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(SPI1_MOSI,       SPI1,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SPI1_SCK,        SPI1,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SPI2_CS0_N,      SPI2,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(SPI2_CS1_N,      SPI2,            PULL_UP,       TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(SPI2_CS2_N,      SPI2,            PULL_DOWN,     TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(SPI2_MISO,       SPI2,            NORMAL,        TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(SPI2_MOSI,       SPI2,            NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(SPI2_SCK,        SPI2,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(DAP3_DIN,        I2S2,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(DAP3_DOUT,       RSVD1,           NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(DAP3_FS,         RSVD1,           NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(DAP3_SCLK,       I2S2,            PULL_DOWN,     NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GPIO_PV0,        RSVD,            NORMAL,        TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(GPIO_PV1,        RSVD,            NORMAL,        TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(ULPI_CLK,        UARTD,           NORMAL,        NORMAL,     OUTPUT), // Function o
	DEFAULT_PINMUX(ULPI_DATA0,      UARTA,           NORMAL,        NORMAL,     OUTPUT), // Function o
	DEFAULT_PINMUX(ULPI_DATA1,      UARTA,           NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(ULPI_DATA2,      UARTA,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(ULPI_DATA3,      UARTA,           NORMAL,        TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(ULPI_DATA4,      UARTA,           NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(ULPI_DATA5,      UARTA,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(ULPI_DATA6,      UARTA,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(ULPI_DATA7,      UARTA,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(ULPI_DIR,        UARTD,           NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(ULPI_NXT,        UARTD,           NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(ULPI_STP,        UARTD,           NORMAL,        NORMAL,     OUTPUT), //G

	/* I2C3 pinmux */
	I2C_PINMUX(CAM_I2C_SCL,		I2C3,		 NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),
	I2C_PINMUX(CAM_I2C_SDA,		I2C3,		 NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),

	DEFAULT_PINMUX(CAM_MCLK,        VI_ALT2,         NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(GPIO_PBB0,       RSVD1,           NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GPIO_PBB3,       VGP3,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GPIO_PBB4,       VGP4,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GPIO_PBB5,       VGP5,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GPIO_PBB6,       VGP6,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GPIO_PBB7,       I2S4,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(GPIO_PCC1,       RSVD1,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(GPIO_PCC2,       I2S4,            NORMAL,        NORMAL,     OUTPUT), // G (NC)

	/* I2C2 pinmux */
	I2C_PINMUX(GEN2_I2C_SCL,	I2C2,		 NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),
	I2C_PINMUX(GEN2_I2C_SDA,	I2C2,		 NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),

	DEFAULT_PINMUX(GMI_A16,         SPI4,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_A17,         SPI4,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_A18,         SPI4,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_A19,         RSVD3,           NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_AD0,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD1,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD2,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD3,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD4,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD5,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD6,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD7,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD8,         PWM0,            NORMAL,        NORMAL,     OUTPUT), // Function o
	DEFAULT_PINMUX(GMI_AD9,         NAND,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_AD10,        NAND,            PULL_DOWN,     NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_AD11,        NAND,            NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_AD12,        NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD13,        NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD14,        NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_AD15,        NAND,            NORMAL,        NORMAL,     INPUT), //G
	DEFAULT_PINMUX(GMI_ADV_N,       NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_CLK,         NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_CS0_N,       NAND,            PULL_UP,       TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_CS1_N,       NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_CS2_N,       RSVD1,           NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_CS3_N,       NAND,            NORMAL,        TRISTATE,   INPUT), //BOARD_ID1
	DEFAULT_PINMUX(GMI_CS4_N,       NAND,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GMI_CS6_N,       NAND_ALT,        NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_CS7_N,       NAND_ALT,        NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GMI_DQS,         RSVD1,           NORMAL,        NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(GMI_IORDY,       RSVD1,           PULL_UP,       TRISTATE,   INPUT), //SD_DET#
	DEFAULT_PINMUX(GMI_OE_N,        NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(GMI_RST_N,       RSVD3,           NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GMI_WAIT,        NAND,            NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GMI_WP_N,        RSVD1,           NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GMI_WR_N,        NAND,            NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(CRT_HSYNC,       CRT,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(CRT_VSYNC,       CRT,             NORMAL,        NORMAL,     OUTPUT), // G (NC)

	/* I2C4 pinmux */
	DEFAULT_PINMUX(DDC_SCL,		I2C4,		 NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(DDC_SDA,		I2C4,		 NORMAL,        NORMAL,     OUTPUT), //G (NC)

	DEFAULT_PINMUX(HDMI_INT,        RSVD0,           NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(LCD_CS0_N,       DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_CS1_N,       DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_D0,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D1,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D2,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D3,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D4,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D5,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D6,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D7,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D8,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D9,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D10,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D11,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D12,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D13,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D14,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D15,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D16,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D17,         DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_D18,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(LCD_D19,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(LCD_D20,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(LCD_D21,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(LCD_D22,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(LCD_D23,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(LCD_DC0,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_DC1,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), //EN_3V3_SDCARD
	DEFAULT_PINMUX(LCD_DE,          DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_HSYNC,       DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_M1,          DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_PCLK,        DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_PWR0,        DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_PWR1,        DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_PWR2,        DISPLAYA,        PULL_DOWN,     NORMAL,     OUTPUT), //G
	DEFAULT_PINMUX(LCD_SCK,         DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_SDIN,        DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_SDOUT,       DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(LCD_VSYNC,       DISPLAYA,        NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(LCD_WR_N,        DISPLAYA,        NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(PEX_L2_CLKREQ_N, PCIE,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(PEX_L2_PRSNT_N,  PCIE,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(PEX_L2_RST_N,    PCIE,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(PEX_WAKE_N,      PCIE,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(CLK2_OUT,        EXTPERIPH2,      NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(CLK2_REQ,        DAP,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(GPIO_PV2,        OWR,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(GPIO_PV3,        RSVD1,           NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SDMMC1_CLK,      SDMMC1,          NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC1_CMD,      SDMMC1,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC1_DAT0,     SDMMC1,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC1_DAT1,     SDMMC1,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC1_DAT2,     SDMMC1,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC1_DAT3,     SDMMC1,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC3_CLK,      SDMMC3,          NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC3_CMD,      SDMMC3,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC3_DAT0,     SDMMC3,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC3_DAT1,     SDMMC3,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC3_DAT2,     SDMMC3,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC3_DAT3,     SDMMC3,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC3_DAT4,     SDMMC3,          NORMAL,        NORMAL,     OUTPUT), //EN_3V3_EMMC
	DEFAULT_PINMUX(SDMMC3_DAT5,     SDMMC3,          NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SDMMC3_DAT6,     SDMMC3,          NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SDMMC3_DAT7,     SDMMC3,          NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(SDMMC4_CLK,      SDMMC4,          NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_CMD,      SDMMC4,          NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT0,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT1,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT2,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT3,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT4,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT5,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT6,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_DAT7,     SDMMC4,          PULL_UP,       NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(SDMMC4_RST_N,    RSVD1,           PULL_UP,       NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(CLK_32K_OUT,     BLINK,           NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(HDMI_CEC,        CEC,             NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(KB_COL0,         KBC,             PULL_UP,       TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(KB_COL1,         KBC,             PULL_UP,       TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(KB_COL2,         KBC,             PULL_UP,       TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(KB_COL3,         KBC,             NORMAL,        NORMAL,     OUTPUT), ////// check config state
	DEFAULT_PINMUX(KB_COL4,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(KB_COL5,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_COL6,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_COL7,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_ROW0,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(KB_ROW1,         RSVD2,           NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(KB_ROW2,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(KB_ROW3,         KBC,             PULL_UP,       NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_ROW4,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_ROW5,         OWR,             NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(KB_ROW6,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_ROW7,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G (Test point)
	DEFAULT_PINMUX(KB_ROW8,         KBC,             PULL_DOWN,     TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(KB_ROW9,         KBC,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_ROW10,        KBC,             NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(KB_ROW11,        KBC,             NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(KB_ROW12,        KBC,             NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(KB_ROW13,        KBC,             PULL_DOWN,     TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(KB_ROW14,        KBC,             NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(KB_ROW15,        KBC,             NORMAL,        TRISTATE,   INPUT), //GI
	DEFAULT_PINMUX(OWR,             OWR,             NORMAL,        NORMAL,     OUTPUT), // G (NC)

	/* Power I2C pinmux */
	I2C_PINMUX(PWR_I2C_SCL,		I2CPWR,          NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),
	I2C_PINMUX(PWR_I2C_SDA,		I2CPWR,          NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),

	DEFAULT_PINMUX(SYS_CLK_REQ,     SYSCLK,          NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(CLK3_OUT,        EXTPERIPH3,      NORMAL,        NORMAL,     OUTPUT), // Function o
	DEFAULT_PINMUX(CLK3_REQ,        DEV3,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(DAP4_DIN,        I2S3,            NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(DAP4_DOUT,       I2S3,            NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(DAP4_FS,         I2S3,            NORMAL,        NORMAL,     INPUT), // Function o
	DEFAULT_PINMUX(DAP4_SCLK,       I2S3,            NORMAL,        NORMAL,     INPUT), // Function o

	/* I2C1 pinmux */
	I2C_PINMUX(GEN1_I2C_SCL,	I2C1,            NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),
	I2C_PINMUX(GEN1_I2C_SDA,	I2C1,            NORMAL,        NORMAL,     INPUT,   DISABLE,   DISABLE),

	DEFAULT_PINMUX(GPIO_PU0,        RSVD1,           NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(GPIO_PU1,        RSVD1,           NORMAL,        NORMAL,     OUTPUT), //G (NC)
	DEFAULT_PINMUX(GPIO_PU2,        RSVD1,           NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(GPIO_PU3,        RSVD1,           NORMAL,        NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(GPIO_PU4,        PWM1,            NORMAL,        NORMAL,     OUTPUT), // G (NC)
	DEFAULT_PINMUX(GPIO_PU5,        PWM2,            NORMAL,        TRISTATE,   INPUT), // GI
	DEFAULT_PINMUX(GPIO_PU6,        RSVD1,           PULL_DOWN,     NORMAL,     OUTPUT), // G
	DEFAULT_PINMUX(UART2_CTS_N,     UARTB,           NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(UART2_RTS_N,     UARTB,           NORMAL,        NORMAL,     OUTPUT), // Function o
	DEFAULT_PINMUX(UART2_RXD,       IRDA,            NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(UART2_TXD,       IRDA,            NORMAL,        NORMAL,     OUTPUT), // Function o
	DEFAULT_PINMUX(UART3_CTS_N,     UARTC,           NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(UART3_RTS_N,     UARTC,           NORMAL,        NORMAL,     OUTPUT), // Function o
	DEFAULT_PINMUX(UART3_RXD,       UARTC,           NORMAL,        NORMAL,     INPUT), // Function
	DEFAULT_PINMUX(UART3_TXD,       UARTC,           NORMAL,        NORMAL,     OUTPUT), // Function o

	/*Add from 14r2*/
	DEFAULT_PINMUX(CLK1_REQ,        DAP,             NORMAL,        NORMAL,     INPUT),
	DEFAULT_PINMUX(PEX_L0_PRSNT_N,  PCIE,            NORMAL,        NORMAL,     INPUT),
	DEFAULT_PINMUX(PEX_L0_RST_N,    PCIE,            NORMAL,        NORMAL,     OUTPUT),
	DEFAULT_PINMUX(PEX_L0_CLKREQ_N, PCIE,            NORMAL,        NORMAL,     INPUT),
	DEFAULT_PINMUX(PEX_L1_PRSNT_N,  PCIE,            NORMAL,        NORMAL,     INPUT),
	DEFAULT_PINMUX(PEX_L1_RST_N,    PCIE,            NORMAL,        NORMAL,     OUTPUT),
	DEFAULT_PINMUX(PEX_L1_CLKREQ_N, PCIE,            NORMAL,        NORMAL,     INPUT),
	DEFAULT_PINMUX(JTAG_RTCK,       RTCK,            NORMAL,        NORMAL,     OUTPUT),
	VI_PINMUX(VI_D6,                VI,              NORMAL,        NORMAL,     OUTPUT,    DISABLE, DISABLE),
	VI_PINMUX(VI_D8,                SDMMC2,          NORMAL,        NORMAL,     INPUT,     DISABLE, DISABLE),
	VI_PINMUX(VI_D9,                SDMMC2,          NORMAL,        NORMAL,     INPUT,     DISABLE, DISABLE),
	VI_PINMUX(VI_PCLK,              RSVD1,           PULL_UP,       TRISTATE,   INPUT,     DISABLE, DISABLE),
	VI_PINMUX(VI_HSYNC,             RSVD1,           NORMAL,        NORMAL,     INPUT,     DISABLE, DISABLE),
	VI_PINMUX(VI_VSYNC,             RSVD1,           NORMAL,        NORMAL,     INPUT,     DISABLE, DISABLE),
	/* SDMMC1 WP gpio */
	DEFAULT_PINMUX(VI_D11,          RSVD1,           PULL_UP,       NORMAL,     INPUT),
};

static struct gpio_table picasso_E2_gpio_unused_init_table[] = {
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP1_DIN
	GPIO_CONFIG(NULL, TEGRA_GPIO_PK6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SPDIF_IN
	GPIO_CONFIG(NULL, TEGRA_GPIO_PK5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SPDIF_OUT
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SPI1_MOSI
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SPI1_SCK
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SPI2_CS0_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SPI2_SCK
	GPIO_CONFIG(NULL, TEGRA_GPIO_PP1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP3_DIN
	GPIO_CONFIG(NULL, TEGRA_GPIO_PO3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // ULPI_DATA2
	GPIO_CONFIG(NULL, TEGRA_GPIO_PO5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), //ULPI_DATA4 (SIM_DET)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PO6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // ULPI_DATA5
	GPIO_CONFIG(NULL, TEGRA_GPIO_PO7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // ULPI_DATA6
	GPIO_CONFIG(NULL, TEGRA_GPIO_PO0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // ULPI_DATA7
	GPIO_CONFIG(NULL, TEGRA_GPIO_PBB3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PBB03
	GPIO_CONFIG(NULL, TEGRA_GPIO_PBB4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PBB04
	GPIO_CONFIG(NULL, TEGRA_GPIO_PBB6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PBB06
	GPIO_CONFIG(NULL, TEGRA_GPIO_PBB7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PBB7
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PCC1
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PCC2
	GPIO_CONFIG(NULL, TEGRA_GPIO_PK2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_CS4_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_CS7_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_RST_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_WAIT
	GPIO_CONFIG(NULL, TEGRA_GPIO_PC7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_WP_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CRT_HSYNC
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CRT_VSYNC
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DDC_SCL
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DDC_SDA
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // HDMI_INT
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_CS0_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PW0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_CS1_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PM2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_18
	GPIO_CONFIG(NULL, TEGRA_GPIO_PM3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_19
	GPIO_CONFIG(NULL, TEGRA_GPIO_PM4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_20
	GPIO_CONFIG(NULL, TEGRA_GPIO_PM5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_21
	GPIO_CONFIG(NULL, TEGRA_GPIO_PM6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_22
	GPIO_CONFIG(NULL, TEGRA_GPIO_PM7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_23
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_DC0
	GPIO_CONFIG(NULL, TEGRA_GPIO_PW1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_M1
	GPIO_CONFIG(NULL, TEGRA_GPIO_PB2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_PWR0
	GPIO_CONFIG(NULL, TEGRA_GPIO_PC1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_PWR1
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_SCK
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_SDIN
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_SDOUT
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // LCD_WR_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // PEX_L2_CLKREQ_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PDD7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // PEX_L2_PRSNT_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // PEX_L2_RST_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PDD3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // PEX_WAKE_N
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CLK2_REQ
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PV2
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PV3
	GPIO_CONFIG(NULL, TEGRA_GPIO_PD0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC3_DAT5
	GPIO_CONFIG(NULL, TEGRA_GPIO_PD3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC3_DAT6
	GPIO_CONFIG(NULL, TEGRA_GPIO_PD4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC3_DAT7
	GPIO_CONFIG(NULL, TEGRA_GPIO_PEE3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // HDMI_CEC
	GPIO_CONFIG(NULL, TEGRA_GPIO_PQ5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_COL5
	GPIO_CONFIG(NULL, TEGRA_GPIO_PQ6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_COL6
	GPIO_CONFIG(NULL, TEGRA_GPIO_PQ7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_COL7
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW11
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW12
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW14
	GPIO_CONFIG(NULL, TEGRA_GPIO_PR3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW3
	GPIO_CONFIG(NULL, TEGRA_GPIO_PR4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW4
	GPIO_CONFIG(NULL, TEGRA_GPIO_PR6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW6
	GPIO_CONFIG(NULL, TEGRA_GPIO_PR7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW7
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_ROW9
	GPIO_CONFIG(NULL, TEGRA_GPIO_PK5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // OWR
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SYS_CLK_REQ
	GPIO_CONFIG(NULL, TEGRA_GPIO_PEE1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CLK3_REQ
	GPIO_CONFIG(NULL, TEGRA_GPIO_PU1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PU1
	GPIO_CONFIG(NULL, TEGRA_GPIO_PU4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GPIO_PU4
};

static struct gpio_table picasso_E2_gpio_sleep_init_table[] = {
	GPIO_CONFIG(NULL, TEGRA_GPIO_PW4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CLK1_OUT (AUDIO_CLK)
#if !defined(CONFIG_ACER_ES305)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP1_FS (AUDIO_RST#)
#endif
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP1_SCLK (AUDIO_SEL)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PA4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP2_DIN (AUDIO_DIN2)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PA5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP2_DOUT (AUDIO_DOUT2)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PA2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP2_FS (AUDIO_FS2)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PA3, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP2_SCLK (AUDIO_SCLK2)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SPI2_MOSI (EN_ES305_OSC)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PP1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP3_DIN (CAM_LED_EN_NV)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PY0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // ULPI_CLK (AUDIO_UART4_TX)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PY1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // ULPI_DIR (AUDIO_UART4_RX)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CAM_MCLK (CAM_MCLK)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PJ7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_A16 (VIB_EN_T30S)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PH2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_AD10 (EN_T30S_FUSE_3V3)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PH1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // GMI_AD9 (DISPOFF#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI7, GPIO_ENABLE, GPIO_HIGH, GPIO_OUTPUT), // GMI_WAIT (3G_DISABLE#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PW5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CLK2_OUT (CP_GPIO)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC1_CLK (SDMMC_CLK)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ1, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC1_CMD (SDMMC_CMD)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PY7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC1_DAT0 (SDMMC_DAT0)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PY6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC1_DAT1 (SDMMC_DAT1)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PY5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC1_DAT2 (SDMMC_DAT2)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PY4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC1_DAT3 (SDMMC_DAT3)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // SDMMC4_CLK (EMMC_CLK)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PT7, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_CMD (EMMC_CMD)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT0 (EMMC_DA0)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT1 (EMMC_DA1)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT2 (EMMC_DA2)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA3, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT3 (EMMC_DA3)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT4 (EMMC_DA4)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT5 (EMMC_DA5)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT6 (EMMC_DA6)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PAA7, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // SDMMC4_DAT7 (EMMC_DA7)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PCC3, GPIO_ENABLE, GPIO_HIGH, GPIO_OUTPUT), // SDMMC4_RST_N (EMMC_RST#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PA0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CLK_32K_OUT (CLK_32K_OUT)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PQ4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // KB_COL4 (BOARD_ID_WP)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PEE0, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // CLK3_OUT (CLK_12M_ES305)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PP5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP4_DIN (BT_PCM_IN)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PP6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP4_DOUT (BT_PCM_OUT)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PP4, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP4_FS (BT_PCM_SYNC)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PP7, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // DAP4_SCLK (BT_PCM_CLK)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PJ5, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // UART2_CTS_N (GPS_UART_CTS#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PJ6, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // UART2_RTS_N (GPS_UART_RTS#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PC3, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), // UART2_RXD (GPS_UART_RXD )
	GPIO_CONFIG(NULL, TEGRA_GPIO_PC2, GPIO_ENABLE, GPIO_LOW, GPIO_OUTPUT), // UART2_TXD (GPS_UART_RXD)

	// Input pins
	GPIO_CONFIG(NULL, TEGRA_GPIO_PN2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //DAP1_DOUT (ES305_INT_R)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX7, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //SPI1_MISO (COMPASS_DRDY)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX3, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //SPI2_CS0_N (LIGHT_INT)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PW2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //SPI2_CS1_N (HP_DET#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PW3, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //SPI2_CS2_N (CDC_IRQ#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PX1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //SPI2_MISO (GYRO_INT_R)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GPIO_PV0 (ON_KEY#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GPIO_PV1 (WAKE_UP_VBUS)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PO4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //ULPI_DATA3 (ULPI_DATA3)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PO5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //ULPI_DATA4 (SIM_DET)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PBB6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GPIO_PBB6 (DOCK_DET#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD0 (NAND_D0)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD1 (BOOT_PD)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD2 (BOOT_PD)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG3, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD3 (BOOT_PD)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD4 (NAND_D4)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD5 (NAND_D5)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD6 (NAND_D6)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PG7, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD7 (NAND_D7)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PH4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD12 (PCB_ID0)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PH5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD13 (PCB_ID1)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PH6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_AD14 (PCB_ID2)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PK0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_ADV_N (BOOT_PD)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PK1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CLK (BOOT_PD)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PJ0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CS0_N (TS_INT#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PJ2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CS1_N (CHARGER_STAT)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PJ3, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CS2_N (BOARD_ID0)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PJ4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CS3_N (BOARD_ID1)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PK2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CS4_N (POUT_3G_1)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI3, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CS6_N (TEMP_ALERT#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_CS7_N (POUT_WIFI)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_IORDY (POUT_3G)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_OE_N (FORCE_RECOVERY#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PC7, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_WP_N (GMI_WP_N)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PI0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GMI_WR_N (NOR_BOOT)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PQ0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_COL0 (SC_LOCK#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PQ1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_COL1 (VOL_DOWN#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PQ2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_COL2 (VOL_UP#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PR1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_ROW1 (BOARD_ID3)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS0, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_ROW8 (SHORT_DET)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_ROW10 (WF_WAKE#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_ROW12 (SD_DET#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_ROW13 (G_ACC_INT)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_ROW14 (LINE_OUT_DET#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PS7, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //KB_ROW15 (BT_IRQ#)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PU5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GPIO_PU5 (DEBUG_UART1_RX_R)

	// I2C pins
	GPIO_CONFIG(NULL, TEGRA_GPIO_PBB1, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //CAM_I2C_SCL (CAM_I2C_SCL)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PBB2, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //CAM_I2C_SDA (CAM_I2C_SDA)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PT5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GEN2_I2C_SCL (GEN2_I2C_SCL)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PT6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GEN2_I2C_SDA (GEN2_I2C_SDA)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //DDC_SCL (DDC_SCL_R)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PV5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //DDC_SDA (DDC_SDA_R)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ6, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //PWR_I2C_SCL (PWR_I2C_SCL)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PZ7, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //PWR_I2C_SDA (PWR_I2C_SDA)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PC4, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GEN1_I2C_SCL (GEN1_I2C_SCL)
	GPIO_CONFIG(NULL, TEGRA_GPIO_PC5, GPIO_ENABLE, GPIO_LOW, GPIO_INPUT), //GEN1_I2C_SCL (GEN1_I2C_SCL)
};
#endif
